package com.javaworld.jpitfalls.article5;

import java.io.*;

public class BadFileRename
{
    public static void main(String args[])
    {       
        try
        {
            // check if test file in current dir
            File f = new File("dummy.txt");
            String name = f.getName();
            if (f.exists())
                System.out.println(f.getName() + " exists.");
            else
                System.out.println(f.getName() + " does not exist.");

            // Attempt to rename to an existing file
            File f2 = new File("dummy.bin");
            // Issue 1: boolean status return instead of Exceptions
            if (f.renameTo(f2))
                System.out.println("Rename to existing File Successful.");
            else
                System.out.println("Rename to existing File Failed.");

            // Attempt to rename with a different extension
            int dotIdx = name.indexOf('.');
            if (dotIdx >= 0)
                name = name.substring(0, dotIdx);
            name = name + ".tst";
            String path = f.getAbsolutePath();
            int lastSep = path.lastIndexOf(File.separator);
            if (lastSep > 0)
                path = path.substring(0,lastSep);
            System.out.println("path: " + path);
            File f3 = new File(path + File.separator + name);
            System.out.println("new name: " + f3.getPath());
            if (f.renameTo(f3))
                System.out.println("Rename to new extension Successful.");
            else
                System.out.println("Rename to new extension failed.");
            
            // delete the file
            // Issue 2: Is the File class a file?
            if (f.delete())
                System.out.println("Delete Successful.");
            else
                System.out.println("Delete Failed.");

            // assumes program not run from c drive
            // Issue 3: Behavior across operating systems?
            File f4 = new File("c:\\" + f3.getName());
            if (f3.renameTo(f4))
                System.out.println("Rename to new Drive Successful.");
            else
                System.out.println("Rename to new Drive failed.");        
        } catch (Throwable t)
         {
            t.printStackTrace();   
         }       
    }        
}
