package com.javaworld.jpitfalls.article5;

import java.io.*;

public class GoodFileRename
{
    public static void main(String args[])
    {       
        try
        {
            // check if test file in current dir
            File f = new File("dummy2.txt");
            String name = f.getName();
            if (f.exists())
                System.out.println(f.getName() + " exists.");
            else
                System.out.println(f.getName() + " does not exist.");

            // Attempt to rename with a different extension
            int dotIdx = name.indexOf('.');
            if (dotIdx >= 0)
                name = name.substring(0, dotIdx);
            name = name + ".tst";
            String path = f.getAbsolutePath();
            int lastSep = path.lastIndexOf(File.separator);
            if (lastSep > 0)
                path = path.substring(0,lastSep);
            System.out.println("path: " + path);
            File f3 = new File(path + File.separator + name);
            System.out.println("new name: " + f3.getPath());
            if (f.renameTo(f3))
                System.out.println("Rename to new extension Successful.");
            else
                System.out.println("Rename to new extension failed.");
            
            // delete the file
            // Fix 1: delete via the "Filename" not File
            if (f3.delete())
                System.out.println("Delete Successful.");
            else
                System.out.println("Delete Failed.");
        } catch (Throwable t)
         {
            t.printStackTrace();   
         }       
    }        
}
